unit LTMain;

{
    A test project for RHCLabel.

    Note: The spin option is purely to show that the label works at all
          rotations, the component itself does not support animation. Also
          it does look a bit wierd when you spin it with RotateChars unset,
          this is a function of the code which works out the inter character
          gap.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RhcLabel, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Timer: TTimer;
    Panel1: TPanel;
    AlignGroup: TRadioGroup;
    LayoutGroup: TRadioGroup;
    Panel2: TPanel;
    Panel3: TPanel;
    ShadowLockBox: TCheckBox;
    Label1: TLabel;
    ShadowAngleEdit: TEdit;
    Label2: TLabel;
    ShadowOffsetEdit: TEdit;
    SpinBox: TCheckBox;
    Label3: TLabel;
    AngleEdit: TEdit;
    TransparentBox: TCheckBox;
    RotateCharBox: TCheckBox;
    CaptionEdit: TEdit;
    RhcLabel: TRhcLabel;
    procedure TimerTimer(Sender: TObject);
    procedure AlignGroupClick(Sender: TObject);
    procedure LayoutGroupClick(Sender: TObject);
    procedure ShadowLockBoxClick(Sender: TObject);
    procedure NumberEditKeyPress(Sender: TObject; var Key: Char);
    procedure ShadowAngleEditChange(Sender: TObject);
    procedure ShadowOffsetEditChange(Sender: TObject);
    procedure SpinBoxClick(Sender: TObject);
    procedure AngleEditChange(Sender: TObject);
    procedure TransparentBoxClick(Sender: TObject);
    procedure RotateCharBoxClick(Sender: TObject);
    procedure CaptionEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.TimerTimer(Sender: TObject);
begin
  RhcLabel.Angle := (RhcLabel.Angle + 10) mod 360;
end;

procedure TForm1.AlignGroupClick(Sender: TObject);
begin
  RhcLabel.Alignment := TAlignment(AlignGroup.ItemIndex);
end;

procedure TForm1.LayoutGroupClick(Sender: TObject);
begin
  RhcLabel.Layout := TTextLayout(LayoutGroup.ItemIndex);
end;

procedure TForm1.ShadowLockBoxClick(Sender: TObject);
begin
  RhcLabel.ShadowLock := ShadowLockBox.Checked;
end;

procedure TForm1.NumberEditKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #8, '-']) then
    Key := #0;
end;

procedure TForm1.ShadowAngleEditChange(Sender: TObject);
begin
  if Length(ShadowAngleEdit.Text) > 0 then
    Rhclabel.ShadowAngle := StrToInt(ShadowAngleEdit.Text);
end;

procedure TForm1.ShadowOffsetEditChange(Sender: TObject);
begin
  if Length(ShadowOffsetEdit.Text) > 0 then
    Rhclabel.ShadowOffset := StrToInt(ShadowOffsetEdit.Text);
end;

procedure TForm1.SpinBoxClick(Sender: TObject);
begin
  Timer.Enabled := SpinBox.Checked;
  AngleEditChange(AngleEdit);
end;

procedure TForm1.AngleEditChange(Sender: TObject);
begin
  if not SpinBox.Checked and (Length(AngleEdit.Text) > 0) then
    RhcLabel.Angle := StrToInt(AngleEdit.Text);
end;

procedure TForm1.TransparentBoxClick(Sender: TObject);
begin
  RhcLabel.Transparent := TransparentBox.Checked;
end;

procedure TForm1.RotateCharBoxClick(Sender: TObject);
begin
  RhcLabel.RotateChars := RotateCharBox.Checked;
end;

procedure TForm1.CaptionEditChange(Sender: TObject);
begin
  RHCLabel.Caption := CaptionEdit.Text;
end;

end.
